local frame = CreateFrame("Frame");

--- Lifetime Vars ---
if not BigMouthClamCounter then BigMouthClamCounter = 0 end
if not GoldenPearlCounter then GoldenPearlCounter = 0 end
if not BlackPearlCounter then BlackPearlCounter = 0 end
if not IridescentPearlCounter then IridescentPearlCounter = 0 end
if not SmallLustrousPearlCounter then SmallLustrousPearlCounter = 0 end
if not LuckIdentifier then LuckIdentifier = "???" end

--- Current Session Vars ---
if not CSBigMouthClamCounter then CSBigMouthClamCounter = 0 end
if not CSGoldenPearlCounter then CSGoldenPearlCounter = 0 end
if not CSBlackPearlCounter then CSBlackPearlCounter = 0 end
if not CSIridescentPearlCounter then CSIridescentPearlCounter = 0 end
if not CSSmallLustrousPearlCounter then CSSmallLustrousPearlCounter = 0 end
if not CSLuckIdentifier then CSLuckIdentifier = "???" end

--- Other ---
if not CMAutoDelete then CMAutoDelete = true end
if not CMAutoScroll then CMAutoScroll = true end

frame:RegisterEvent('BAG_UPDATE_DELAYED')
frame:RegisterEvent('PLAYER_ENTERING_WORLD')
frame:RegisterEvent('LOOT_CLOSED')
frame:RegisterEvent("CHAT_MSG_LOOT");
frame:RegisterEvent("ADDON_LOADED");

--- Widget ---
local f = CreateFrame("Frame", "CMFrame", UIParent)
f:SetMovable(true)
f:EnableMouse(true)
f:RegisterForDrag("LeftButton")
f:SetScript("OnDragStart", frame.StartMoving)
f:SetScript("OnDragStop", frame.StopMovingOrSizing)
f:SetWidth(230) 
f:SetHeight(160)
f:SetBackdrop({
	bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
	edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
	edgeSize = 16,
	insets = { left = 4, right = 4, top = 4, bottom = 4 },
})
f:SetBackdropColor(0, 0, 1, .95)

--- Header Texture ---
local headerTexture = f:CreateTexture(nil, "OVERLAY")
headerTexture:SetSize(225, 64)
headerTexture:SetPoint("CENTER", 0, 64)
headerTexture:SetTexture("Interface/DialogFrame/UI-DialogBox-Header")

--- Header ---
local header = f:CreateFontString(f, "OVERLAY", "GameFontNormal")
header:SetPoint("CENTER", 0, 75)
header:SetText("|cffFF0000Clam Master|r");

--- Items ---
local ItemsTitle = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
ItemsTitle:SetPoint("LEFT", 40, 45)
ItemsTitle:SetText("|cffFF0000Items|r");

local bigMouthClamTitle = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
bigMouthClamTitle:SetPoint("LEFT", 10, 30)
bigMouthClamTitle:SetText("|cffFFFFFFBig-mouth Clams|r");

local goldenPearlsTitle = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
goldenPearlsTitle:SetPoint("LEFT", 10, 15)
goldenPearlsTitle:SetText("|cffFFFFFFGolden Pearls|r");

local blackPearlsTitle = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
blackPearlsTitle:SetPoint("LEFT", 10, 0)
blackPearlsTitle:SetText("|cffFFFFFFBlack Pearls|r");

local iridescentPearlsTitle = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
iridescentPearlsTitle:SetPoint("LEFT", 10, -15)
iridescentPearlsTitle:SetText("|cffFFFFFFIridescent Pearls|r")

local smallLustrousPearlsTitle = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
smallLustrousPearlsTitle:SetPoint("LEFT", 10, -30)
smallLustrousPearlsTitle:SetText("|cffFFFFFFSmall Lustrous Pearls|r")

local CSLuckTitle = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
CSLuckTitle:SetPoint("LEFT", 10, -50)
CSLuckTitle:SetText("|cfff5ef42I have been|r " .. LuckIdentifier .. " |cfff5ef42during my|r |cffFF0000LS|r")

local LuckTitle = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
LuckTitle:SetPoint("LEFT", 10, -65)
LuckTitle:SetText("|cfff5ef42I have been|r " .. CSLuckIdentifier .. " |cfff5ef42during my|r |cffFF0000CS|r")


--- Lifetime Session ---
local LifetimeTitle = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
LifetimeTitle:SetPoint("Center", 50, 45)
LifetimeTitle:SetText("|cffFF0000LS|r");

local bigMouthClamCount = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
bigMouthClamCount:SetPoint("CENTER", 50, 30)
bigMouthClamCount:SetText("|cff00FF00".. BigMouthClamCounter .. "|r");

local goldenPearlsCount = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
goldenPearlsCount:SetPoint("CENTER", 50, 15)
goldenPearlsCount:SetText("|cff00FF00" .. GoldenPearlCounter .. "|r");

local blackPearlsCount = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
blackPearlsCount:SetPoint("CENTER", 50, 0)
blackPearlsCount:SetText("|cff00FF00" .. BlackPearlCounter .. "|r")

local iridescentPearlsCount = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
iridescentPearlsCount:SetPoint("CENTER", 50, -15)
iridescentPearlsCount:SetText("|cff00FF00" .. IridescentPearlCounter .. "|r")

local smallLustrousPearlsCount = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
smallLustrousPearlsCount:SetPoint("CENTER", 50, -30)
smallLustrousPearlsCount:SetText("|cff00FF00" .. SmallLustrousPearlCounter .. "|r");


--- Current Session ---
local CurrentSessionTitle = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
CurrentSessionTitle:SetPoint("RIGHT", -20, 45)
CurrentSessionTitle:SetText("|cffFF0000CS|r");

local csbigMouthClamCount = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
csbigMouthClamCount:SetPoint("RIGHT", -20, 30)
csbigMouthClamCount:SetText("|cff00FF00".. CSBigMouthClamCounter .. "|r");

local csgoldenPearlsCount = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
csgoldenPearlsCount:SetPoint("RIGHT", -20, 15)
csgoldenPearlsCount:SetText("|cff00FF00" .. CSGoldenPearlCounter .. "|r");

local csblackPearlsCount = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
csblackPearlsCount:SetPoint("RIGHT", -20, 0)
csblackPearlsCount:SetText("|cff00FF00" .. CSBlackPearlCounter .. "|r")

local csiridescentPearlsCount = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
csiridescentPearlsCount:SetPoint("RIGHT", -20, -15)
csiridescentPearlsCount:SetText("|cff00FF00" .. CSIridescentPearlCounter .. "|r")

local cssmallLustrousPearlsCount = f:CreateFontString(f, "OVERLAY", "GameTooltipText")
cssmallLustrousPearlsCount:SetPoint("RIGHT", -20, -30)
cssmallLustrousPearlsCount:SetText("|cff00FF00" .. CSSmallLustrousPearlCounter .. "|r");


frame:SetScript("OnEvent", function(self, event, arg1, ...)
	local lootedSomethingUseful, firstLoadIn = false, false
    if event == "ADDON_LOADED" and arg1 == "ClamMaster" then
      print("|cffFF0000[Clam Master]|r Loaded - made by Ubz");
    frame:UnregisterEvent('ADDON_LOADED')
    firstLoadIn = true
	elseif event == "CHAT_MSG_LOOT" and strfind(arg1, "^You receive loot:") then
	  if strfind(arg1, "Big-mouth Clam", 1, true) then
        BigMouthClamCounter = BigMouthClamCounter + 1;
        CSBigMouthClamCounter = CSBigMouthClamCounter + 1;
	    lootedSomethingUseful = true
      elseif strfind(arg1, "Golden Pearl", 1, true) then
        GoldenPearlCounter = GoldenPearlCounter + 1;
        CSGoldenPearlCounter = CSGoldenPearlCounter + 1;
        PlaySound(2725)
        print("|cffFF0000[ClamMaster]|r - Congratulations, you've looted a Golden Pearl!");
	    lootedSomethingUseful = true
      elseif strfind(arg1, "Black Pearl", 1, true) then
        BlackPearlCounter = BlackPearlCounter + 1;
        CSBlackPearlCounter = CSBlackPearlCounter + 1;
	    lootedSomethingUseful = true
	  elseif strfind(arg1, "Iridescent Pearl", 1, true) then
		IridescentPearlCounter = IridescentPearlCounter + 1;
		CSIridescentPearlCounter = CSIridescentPearlCounter + 1;
		lootedSomethingUseful = true
      elseif strfind(arg1, "Small Lustrous Pearl", 1, true) then
		SmallLustrousPearlCounter = SmallLustrousPearlCounter + 1;
		CSSmallLustrousPearlCounter = CSSmallLustrousPearlCounter + 1;
		lootedSomethingUseful = true
	  end
    end

    --- Lucky or Unlucky Lifetime Session ---
    expectedGoldenPearlCount = BigMouthClamCounter*0.005;

    if expectedGoldenPearlCount >= 1 and expectedGoldenPearlCount >= GoldenPearlCounter then
      LuckIdentifier = "|cffC24B4BUnlucky|r"
    elseif GoldenPearlCounter >= expectedGoldenPearlCount then
      LuckIdentifier = "|cff51C431Lucky|r"
    end
    --- Lucky or Unlucky Current Session ---
    csexpectedGoldenPearlCount = CSBigMouthClamCounter*0.005;

    if csexpectedGoldenPearlCount >= 1 and csexpectedGoldenPearlCount >= CSGoldenPearlCounter then
      CSLuckIdentifier = "|cffC24B4BUnlucky|r"
    elseif CSGoldenPearlCounter > csexpectedGoldenPearlCount then
      CSLuckIdentifier = "|cff51C431Lucky|r"
    end

	
	if lootedSomethingUseful or firstLoadIn then
		bigMouthClamCount:SetText("|cff00FF00".. BigMouthClamCounter .. "|r")
		goldenPearlsCount:SetText("|cff00FF00" .. GoldenPearlCounter .. "|r")
		blackPearlsCount:SetText("|cff00FF00" .. BlackPearlCounter .. "|r")
		iridescentPearlsCount:SetText("|cff00FF00" .. IridescentPearlCounter .. "|r")
		smallLustrousPearlsCount:SetText("|cff00FF00" .. SmallLustrousPearlCounter .. "|r")
    csbigMouthClamCount:SetText("|cff00FF00".. CSBigMouthClamCounter .. "|r")
		csgoldenPearlsCount:SetText("|cff00FF00" .. CSGoldenPearlCounter .. "|r")
		csblackPearlsCount:SetText("|cff00FF00" .. CSBlackPearlCounter .. "|r")
		csiridescentPearlsCount:SetText("|cff00FF00" .. CSIridescentPearlCounter .. "|r")
    cssmallLustrousPearlsCount:SetText("|cff00FF00" .. CSSmallLustrousPearlCounter .. "|r")
    LuckTitle:SetText("|cfff5ef42I have been|r " .. LuckIdentifier .. " |cfff5ef42during my|r |cffFF0000LS|r")
    CSLuckTitle:SetText("|cfff5ef42I have been|r " .. CSLuckIdentifier .. " |cfff5ef42during my|r |cffFF0000CS|r")
	end

--- Auto Open Clam and Zesty Clam Meat deletion ---
    for bag = 0, 4 do
        for slot = 1, GetContainerNumSlots(bag) do
            local item = GetContainerItemLink(bag, slot)
            if item and item:find('Big%-mouth Clam') then
                UseContainerItem(bag, slot)
            elseif item and item:find('Zesty Clam Meat') and CMAutoDelete == true  then
                PickupContainerItem(bag, slot)
                DeleteCursorItem()   
            end
        end
    end
end)


--- Prints out statistics of lifetime and current session ---
SLASH_ClamMaster1 = "/cm";
SlashCmdList["ClamMaster"] = function(msg)
  print("-----------< |cffFF0000Clam Master|r |cff00FF00Commands|r >-------------")
  print("• |cff00FF00/cm|r - shows all of the commands available")
  print("• |cff00FF00/cmr|r - resets current session")
  print("• |cff00FF00/cmshow|r - shows the widget")
  print("• |cff00FF00/cmhide|r - hides the widget")
  print("• |cff00FF00/cmwr|r - resets the position of your widget")
  print("• |cff00FF00/cmadt|r - toggles the auto-delete feature on/off")
  print("• |cff00FF00/cmhl|r - tells you how lucky/unlucky you've been")
  print("-------------------------------------------------------------")
end

--- Resets Current Session ---
SLASH_ClamMasterReset1 = "/cmr";
SlashCmdList["ClamMasterReset"] = function(msg)
  CSBigMouthClamCounter = 0;
  CSGoldenPearlCounter = 0;
  CSBlackPearlCounter = 0;
  CSIridescentPearlCounter = 0;
  CSSmallLustrousPearlCounter = 0;
  csexpectedGoldenPearlCount = 0;
  csbigMouthClamCount:SetText("|cff00FF00".. CSBigMouthClamCounter .. "|r")
  csgoldenPearlsCount:SetText("|cff00FF00" .. CSGoldenPearlCounter .. "|r")
  csblackPearlsCount:SetText("|cff00FF00" .. CSBlackPearlCounter .. "|r")
  csiridescentPearlsCount:SetText("|cff00FF00" .. CSIridescentPearlCounter .. "|r")
  cssmallLustrousPearlsCount:SetText("|cff00FF00" .. CSSmallLustrousPearlCounter .. "|r")
  print("|cffFF0000[Clam Master]|r - Your current session is now reset!");
end

--- Opens Window ---
SLASH_ClamMasterShow1 = "/cmshow";
SlashCmdList["ClamMasterShow"] = function(msg)
  CMFrame:Show();
end

--- Hides Window ---
SLASH_ClamMasterHide1 = "/cmhide";
SlashCmdList["ClamMasterHide"] = function(msg)
  CMFrame:Hide();
end

--- Resets Current Session ---
SLASH_ClamMasterWidgetReset1 = "/cmwr";
SlashCmdList["ClamMasterWidgetReset"] = function(msg)
  CMFrame:ClearAllPoints()
  CMFrame:SetPoint("CENTER", 0, 0)
  print("|cffFF0000[Clam Master]|r - The position of your widget is now reset!");
end

--- Toggles auto deletion on/off ---
SLASH_ClamMasterAutoDeleteToggle1 = "/cmadt";
SlashCmdList["ClamMasterAutoDeleteToggle"] = function(msg)
  if CMAutoDelete == true then 
    CMAutoDelete = false
    print("|cffFF0000[Clam Master]|r - Auto deletion has been turned |cffFF0000OFF|r!");
  elseif CMAutoDelete == false then
    CMAutoDelete = true
    print("|cffFF0000[Clam Master]|r - Auto deletion has been turned |cff00FF00ON|r!");
  end
end

--- Shows how Lucky/Unlucky you've been ---
SLASH_ClamMasterHowLucky1 = "/cmhl";
SlashCmdList["ClamMasterHowLucky"] = function(msg)
  local HowLucky = string.format("%.1f", BigMouthClamCounter*0.005)
  print("|cffFF0000[CM]|r So far you've been " .. LuckIdentifier .. " and at this point you've obtained |cff00FF00" .. GoldenPearlCounter .. "|r |cffFDCC51Golden Pearls|r, and should've gotten |cff00FF00" .. HowLucky .. "|r |cffFDCC51Golden Pearls|r.")
end
